## mingw-w64-vtk-9.5.2-1.src.tar.zst

=== IO/Legacy/CMakeLists.txt ===
set(classes
  vtkCompositeDataReader
  vtkCompositeDataWriter
  vtkDataObjectReader
  vtkDataObjectWriter
  vtkDataReader
  vtkDataSetReader
  vtkDataSetWriter
  vtkDataWriter
  vtkGenericDataObjectReader
  vtkGenericDataObjectWriter
  vtkGraphReader
  vtkGraphWriter
  vtkLegacyCellGridReader
  vtkLegacyCellGridWriter
  vtkPixelExtentIO
  vtkPolyDataReader
  vtkPolyDataWriter
  vtkRectilinearGridReader
  vtkRectilinearGridWriter
  vtkSimplePointsReader
  vtkSimplePointsWriter
  vtkStructuredGridReader
  vtkStructuredGridWriter
  vtkStructuredPointsReader
  vtkStructuredPointsWriter
  vtkTableReader
  vtkTableWriter
  vtkTreeReader
  vtkTreeWriter
  vtkUnstructuredGridReader
  vtkUnstructuredGridWriter)

vtk_module_add_module(VTK::IOLegacy
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IOLegacy)
